//---------------keypad------------------
#include <Keypad.h> //keypad library info

const byte ROWS = 4; //four rows
const byte COLS = 4; //four columns

//declares the each key value individually
char keys[ROWS][COLS] = {
  {'1','2','3','A'},
  {'4','5','6','B'},
  {'7','8','9','C'},
  {'*','0','#','D'}
};

//declares which ports it is plugged into
byte rowPins[ROWS] = {9, 8, 7, 6}; 
byte colPins[COLS] = {5, 4, 3, 2};

//object creation called keypad to map out the key values and their location
Keypad keypad = Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS );

//--------------------neopixel-------------------
//https://adafruit.github.io/Adafruit_NeoPixel/html/class_adafruit___neo_pixel.html 
#include <Adafruit_NeoPixel.h> //neopixel library info

#define PIN 11	 // input pin Neopixel is attached to

#define NUMPIXELS 8 // number of neopixels in strip

Adafruit_NeoPixel pixels = Adafruit_NeoPixel(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

//declaring the colors of the rainbow to an array to use later
int colorShow[8][3]={
  {255, 0, 0}, //red
  {255, 162, 0}, //orange
  {255, 247, 0}, //yellow
  {34, 255, 0}, //green
  {0, 208, 255}, //light blue
  {0, 34, 255}, //dark blue
  {191, 0, 255}, //purple
  {255, 0, 153} //pink
};

//-----------------------------------------
void setup()
{
  pixels.begin(); //prepares neopixel
  for (int x=0; x < NUMPIXELS; x++){
  pixels.setPixelColor(x, 0, 0, 0); //set all lights to off
  pixels.show();
  }
  
  Serial.begin(9600);
  Serial.print("How many main pyramids are within the Giza Pyramid Complex?");
}

void loop()
{
  char key = keypad.getKey(); //record which key is pressed
  
  if(key){ 
   //if a key is pressed, display it on serial monitor
   Serial.println("");
   Serial.println(key);
    
   	char userInput = key;
    char answer = '3'; 
    
    	//correct answer
    	if(userInput == answer){
         Serial.println("You got it!");
       	//while loop makes the light show infinite, turning off and on
          while(true){
            //used for calling values from colorShow array
            int y = 0;
            int x = 0;
            for(int i=0;i < NUMPIXELS;i++){
              //this loop cycles through colors declared in colorShow array
                delay(100);
           		pixels.setPixelColor(i, colorShow[y][x], colorShow[y][x+1], colorShow[y][x+2]);
           		pixels.show();
            	y += 1;
            	x *= 0;
            }
            for(int i=0;i < NUMPIXELS;i++){
              //this loop turns off all the lights
              delay(100);
              pixels.setPixelColor(i, 0, 0, 0);
              pixels.show();
            }
           }
        }
          
    	//incorrect answer
  		else if(userInput != answer){
          //blink the red strip once
          for(int y=0; y < 1; y++){
    		for (int i=0; i < NUMPIXELS; i++){
            delay(100);
    		pixels.setPixelColor(i, 255, 0, 0); //set all lights to red
    		pixels.show();
    		}
        	for (int i=0; i < NUMPIXELS; i++){
            delay(100);
    		pixels.setPixelColor(i, 0, 0, 0); //turn off all lights
    		pixels.show();
    		}
           Serial.println("Try Again");
          }
   		}
	}
}